#ifndef STOREDEV_RAMSD_H_
#define STOREDEV_RAMSD_H_

#include <stdint.h>
#include <stddef.h>

#define STOREDEV_RAMSD_SECTORSIZE 512

struct StoreDev;

typedef struct {
  size_t capacity;
  uint8_t *buffer;
} RamSd;

typedef struct {
  size_t capacity;
  uint8_t *preallocbuffer;
} RamSdInitExtra;

int32_t ramsd_init(struct StoreDev *sd, void *extra);
int32_t ramsd_read(struct StoreDev *sd, uint8_t *const buffer, ptrdiff_t sector, ptrdiff_t off, size_t size);
int32_t ramsd_write(struct StoreDev *sd, const uint8_t *const buffer, ptrdiff_t sector, ptrdiff_t off, size_t size);
int32_t ramsd_cleanup(struct StoreDev *sd);
size_t ramsd_capacity(struct StoreDev *sd);

#endif // STOREDEV_RAMSD_H_
